 // LCD module connections
//XTAL FREQUENCY MUST AND SHOULD BE USED AS 12MHZ BASED ON PROGRAMMING SETTINGS
sbit IR_PIN at RC4_bit;
sbit rly1 at RC0_bit;
sbit rly2 at RC1_bit;
sbit rly3 at RC2_bit;
char text[5];
unsigned long ir_code;
unsigned int address;
unsigned short command, inv_command;

short nec_remote_read() {
  unsigned long count = 0, i;
  // Check 9ms pulse (remote control sends logic high)
  while ((IR_PIN == 0) && (count <= 180)) {
    count++;
    Delay_us(50);
  }
  if ( (count > 179) || (count < 120))     // NEC protocol?
    return 0;

  count = 0;
  // Check 4.5ms space (remote control sends logic low)
  while (IR_PIN && (count <= 90)) {
    count++;
    Delay_us(50);
  }
  if ( (count > 89) || (count < 40))       // NEC protocol?
    return 0;

  // Read code message (32-bit)
  for (i = 0; i < 32; i++) {
    count = 0;
    while ((IR_PIN == 0) && (count <= 23)) {
      count++;
      Delay_us(50);
    }
    if ( (count > 22) || (count < 4))     // NEC protocol?
      return 0;

    count = 0;
    while (IR_PIN && (count <= 45)) {
      count++;
      Delay_us(50);
    }
    if ( (count > 44) || (count < 8))     // NEC protocol?
      return 0;

    if ( count > 21)                      // If space width > 1ms
      ir_code |= 1ul << (31 - i);         // Write 1 to bit (31 - i)
    else                                  // If space width < 1ms
      ir_code &= ~(1ul << (31 - i));      // Write 0 to bit (31 - i)
  }
  return 1;
}

void main()
{   
  ANSEL=0x00;//all pins are digital
  CMCON = 0x07 ; // Disbale comparators
  TRISC = 0b00010000;
  rly1=rly2=rly3=0;
  rly1 = ~rly1;
  Delay_ms(1000);
  rly1 = ~rly1;
  Delay_ms(1000);
  
  rly1 = ~rly1;
  Delay_ms(1000);
  rly1 = ~rly1;
  Delay_ms(1000);
  
  rly1 = ~rly1;
  Delay_ms(1000);
  rly1 = ~rly1;
  Delay_ms(1000);

  while (1) { //Loop executed infinite times

    while (IR_PIN);                //Wait until IR pin falls
    if (nec_remote_read()) {
      address = ir_code >> 16;
      command = ir_code >> 8;
      inv_command = ir_code;

switch(command) {
/*
case 0x48://power button
break;
case 0x58://mode button
break;
case 0x78://mute button
break;
case 0x80://play/pause button
break;
case 0x40://reverse button
break;
case 0xc0://forward button
break;
case 0x20://EQ button
break;
case 0xA0://VOL- button
break;
case 0x60://VOL+ button
break;
case 0xE0://0 button
break;
case 0x10://RPT button
break;
case 0x90://U/SD button
break;
case 0x50://1 button
break; */
case 0xD8://2 button
rly1 = ~rly1;
Delay_ms(50);
break;
case 0xF8://3 button
Delay_ms(1);
break;
case 0x30://4 buttonm
rly2 = ~rly2;
Delay_ms(50);
break;
case 0xB0://5 button
break;
case 0x70://6 button
rly3 = ~rly3;
Delay_ms(50);
break;
/*case 0x00://7 button
break;
case 0xF0://8 button
break;
case 0x98://9 button
break;*/
default:
break;
}}}}
            